<cfparam name="attributes.output" default="">
<cfparam name="attributes.type" default="query">

<cfif NOT thisTag.hasEndTag>
The custom tag <strong>&lt;cf_dataValidate&gt;</strong> requires an end tag.
<cfabort>
</cfif>

<cfif Len(Trim(attributes.output)) EQ 0>
You must pass a value for the attribute OUTPUT for <strong>&lt;cf_dataValidate&gt;</strong>.
<cfabort>
</cfif>

<cfif  Len(Trim(attributes.type)) EQ 0>
You must specify and pass a value for the attribute TYPE in <strong>&lt;cf_dataValidate&gt;</strong>. QUERY and STRUCTURE are the only valid values.
<cfabort>
<cfelseif ListFindNoCase("query,structure",attributes.type) EQ 0>
QUERY and STRUCTURE are the only valid values for TYPE in <strong>&lt;cf_dataValidate&gt;</strong>.
<cfabort>
</cfif>


<cfscript>
if (Len(Trim(attributes.output)) EQ 0)
	{WriteOutput("You must pass a value for the attribute OUTPUT.");}
	
if(ListFindNoCase("query,structure",attributes.type) EQ 0)
	{WriteOutput("QUERY and STRUCTURE are the only valid values for TYPE");}
	
switch(ThisTag.ExecutionMode)
	{
	case "start":
		if (NOT IsDefined("attributes.output"))
		attributes.output="qryErrors";
		if (NOT IsDefined("request.setErrors"))
		request.setErrors="";
		if (NOT IsArray(request.setErrors))
		request.setErrors=ArrayNew(2);
	break;

	case "end":
		switch(attributes.type)
			{
			case "query":
				qry_Errors=QueryNew("");
				QueryAddColumn(qry_Errors,  "message",  request.setErrors[1]);
				"caller.#attributes.output#"=Duplicate(qry_Errors);
			break;
			
			case "structure":
				stCreateErrors=StructNew();
				FOR (index=1; index LTE ArrayLen(request.setErrors[1]); index=index+1)
					{
					if (StructKeyExists(variables.stCreateErrors, request.setErrors[2][index]))
						{
						stCreateErrors[request.setErrors[2][index]]=ListAppend(stCreateErrors[request.setErrors[2][index]],request.setErrors[1][index],"|");
						stCreateErrors[request.setErrors[2][index]]=ListChangeDelims(stCreateErrors[request.setErrors[2][index]],  "<br>", "|");
						}
					else
						{
						stCreateErrors[request.setErrors[2][index]]=request.setErrors[1][index];
						}
					}
				"caller.#attributes.output#"=Duplicate(stCreateErrors);
			break;			
			}	
	break;
	}
</cfscript>
